;ztt4cnf.lst
;Copyright (C) 2004-2005 by C. Bradford Barber
;$Id: //product/ttcnf/main/src/ztt4cnf.asm#1 $
;$DateTime: 2008/03/16 14:47:31 $$Change: 844 $$Author: bbarber $
	include tt_all.sym
	
;;test truth table for K-cnf for N variables, ...
;
;	Task->kcnf
;	DH= numcnf, e.g., 3-cnf
;	DL= numvar, 3, 4, or 5
;	    0509 is 5-CNF with 9 vars, i.e., 4-CNF+E, 4-CNF, 3-CNF+E, 3-CNF, 2-CNF+E, 2-CNF, 1-CNF+E, 1-CNF, E
;	    0508 is 5-CNF with 8 vars, i.e., 4-CNF+E, 4-CNF, 3-CNF+E, 3-CNF, 2-CNF+E, 2-CNF, 1-CNF+E
;	    0507 is 5-CNF with 7 vars, i.e., 4-CNF+E, 4-CNF, 3-CNF+E, 3-CNF, 2-CNF+E
;	    0506 is 5-CNF with 6 vars, i.e., 4-CNF+E, 4-CNF, 3-CNF+E
;	    0505 is 5-CNF with 5 vars, i.e., 4-CNF+E
;	    0408 is 4-CNF with 8 vars, i.e., 4-CNF, 3-CNF+E, 3-CNF, 2-CNF+E, 2-CNF, 1-CNF+E, 1-CNF, E
;	    0407 is 4-CNF with 7 vars, i.e., 4-CNF, 3-CNF+E, 3-CNF, 2-CNF+E, 2-CNF, 1-CNF+E
;	    0406 is 4-CNF with 6 vars, i.e., 4-CNF, 3-CNF+E, 3-CNF, 2-CNF+E
;	    0405 is 4-CNF with 5 vars, i.e., 4-CNF, 3-CNF+E
;	    0404 is 4-CNF with 4 vars, i.e., 4-CNF
;	    0307 is 3-CNF with 7 vars, i.e., 3-CNF, 2-CNF+E, 2-CNF, 1-CNF+E, 1-CNF, E
;	    0306 is 3-CNF with 6 vars, i.e., 3-CNF, 2-CNF+E, 2-CNF, 1-CNF+E
;	    0305 is 3-CNF with 5 vars, i.e., 3-CNF, 2-CNF+E
;	    0304 is 3-CNF with 4 vars, i.e., 3-CNF
;	    0206 is 2-CNF with 6 vars, i.e., 2-CNF, 1-CNF+E, 1-CNF, E
;	    0205 is 2-CNF with 5 vars, i.e., 2-CNF, 1-CNF+E
;	    0204 is 2-CNF with 4 vars, i.e., 2-CNF
;	    0104 is 1-CNF with 4 vars, i.e., 1-CNF
;	    also 0303, 0203, 0202, 0103, 0102
;	ss:cnttt also defined
;	ss:flagstt= .ttlownibbles and/or .ttlowbytes
;returns:
;	ecx,esi preserved
;	alltt,... |= bit set for computed truth tables
;
;design:
;    for each k-choose var
;      	for each complement
;	    compute new clause
;	    compute new truth-table, i
;	    set alltt[i]
;
;group: truth.-table
; call: ztttest
; xref: zttcnf ztt4clause ztt4cnf0

  ;proccall <norm>,<eax,ecx,edx>,'ztt4cnf: test truth table @dh.dec-CNF of @dl.dec vars EachRun @al.hexb MaxClause @ecx.dec'
tt_runTT_c PROC Task, Truthtables
  pushm	ebx,esi,edi ;preserved
  mov	edi,Truthtables
  clear	esi
  mov	ebx,Task
  mov	edx,[ebx].maxStart
  shr	edx,2
  FIXUP ;check fractional maxStart
  check tt_FLAGSperByte,eq,4 ;and 4 bytes per INT
  clear ebx
aa@loop: 	;DS:EBX= Truthtables.index, EDX= EndIndex, ESI= TT, EDI= Truthtables
  mov	eax,[edi+ebx].dword0
  ifzero eax
  jnz	aa@maytt16
  add	esi,tt_FLAGSperInt
aa@next:
  add	ebx,4
  cmp	ebx,edx
  jb	aa@loop
  jmp	aa@exit
aa@maytt16:
  push	edx ;TT.endIndex
  mov	edx,tt_FLAGSperInt    ;;...repeat for 16 TTs
  mov	ecx,tt_NEW
aa@ttloop:  ;EDX=.count, EBX=.index, ECX=FLAGSmask, EAX=TT bits, ESI= TT, EDI= Truthtables
  shr	eax,1
  check tt_NEW,eq,1
  jc	aa@maytt
  shr	eax,1
  check tt_BITSperFlags,eq,2
aa@ttnext:	
  rol	ecx,tt_BITSperFlags
  inc	esi
  dec	edx
  jnz	aa@ttloop
  pop	edx ;TT.endIndex
  jmp	aa@next
aa@maytt:
  shr	eax,1
  check tt_SEEN,eq,2
  check tt_BITSperFlags,eq,2
  jc	aa@ttnext
  add	[edi+ebx].dword0,ecx	; clear tt_NEW and set tt_SEEN
  check	tt_SEEN,eq,tt_NEW+1
  pushm	eax,ebx,ecx,edx		    ;;....update counts for all clauses of TruthTable
  mov	ebx,Task
  mov	edx,[ebx].kcnf
  push	ebx ;Task
  invoke	tt_setAllClause_c ;esi,edi,>ttwas0,eax
  pop	ebx
  jnc	aa@not0					;;....if TruthTable.was0
  mov	[ebx].maxActive,esi		;;.....update CurMaxTT [always increases from 0]
aa@not0:
  add	[ebx].totSame,eax
  jnc	@F
  inc	[ebx].totSame2
@@:
  ;and	ss:flagstt,not ttlogcnf0 ;log first round
  popm	edx,ecx,ebx,eax
  jmp	aa@ttnext
aa@exit:
  popm	edi,esi,ebx ;preserved
  ret	
  ; procret <norm>,<noresult>,'ztt4cnf'
tt_runTT_c ENDP

  END
  
