;ztt8cnt.lst
;Copyright (C) 2004-2005 by C. Bradford Barber
;$Id: //product/ttcnf/main/src/ztt4cnt.asm#1 $
;$DateTime: 2008/03/16 14:47:31 $$Change: 844 $$Author: bbarber $
	include tt_all.sym

;;count non-zeros in TruthTables
;
;	AX:BX= TTMask
;	SI:DI= CurMax
;	DX= CNF
;	CX= Length
;	DS= alltt
;	ss:cnttt= ttstats array
;returns:
;	ES destroyed
;	reports error with all stats
;notes:
;	tried counting bits in truthtable, but sorting by high bits more useful
;	within a range of high bits, the number of bits may be helpful
;	    mov   ax,si		;;...count Bits in t
;	    callz zbitcnt ;dx,si,di,>cx
;
;group: truth.-table
; call: ztt8cnf
; xref: zttstat zttcnt

  ;proccall <norm>,<ax,bx,cx,dx,si,di>,'ztt8cnt: count non-zeros in truth tables, CNF @dx.hex Length @cx.dec Mask @ax.hex.bx.hex CurMax @di.hex.si.hex'
tt_statisticsTT_c PROC Task, Truthtables
  pushm	ebx,esi,edi ;preserved
  mov	edi,Truthtables			;;..for each TruthTable in TruthTables
  mov	ebx,Task
  cmp	[ebx].stats,0
  jne	@F
  add	ebx,ttline
  DSstr esi,'tt_statisticsTT_c: Statistics array was not allocated for Task "%s"'
  pushm	ebx,esi,tt_ERRrun
  invoke tt_errexit ;never returns
@@:
  mov	edx,[ebx].maxStart
  shr	edx,2
  FIXUP ;check fractional maxStart
  check tt_FLAGSperByte,eq,4 ;and 4 bytes per INT
  clear	esi						
  clear ebx
aa@loop: 	;DS:EBX= Truthtables.index, EDX= EndIndex, ESI= TT, EDI= Truthtables
  mov	eax,[edi+ebx].dword0
  pushm	ebx,edx,edi ;TT.index,TT.endIndex, Truthtables
  mov	ebx,Task
  ifzero edx				  ;;...if Truthtables.endIndex.isZero
  mov	edx,2				  ;;.....repeat of 2 TTs
  jz	@F					  ;;....else
  mov	edx,tt_FLAGSperInt    ;;.....repeat for 16 TTs
@@:
aa@ttloop:  ;EAX=TT bits, EBX= Task, EDX=.count, ESI= TT, EDI= Truthtables
  push	edx ;Count
  push	eax ;TT bits
  call	aa@getbucket ;ebx,esi,edi,>edx
  cmp	edx,tt_NUMbuckets
  jb	@F
  mov	edx,tt_NUMbuckets-1
@@:
  pop	eax ;TT bits
  push	eax
  push	ebx ;Task
  mov	ebx,[ebx].stats
  add	ebx,stnone
  and	eax,tt_FLAGS
  jz	aa@bucket
  add	ebx,stnew-stnone
  dec	eax
  jz	aa@bucket
  add	ebx,stseen-stnew
  dec	eax
  jz	aa@bucket
  add	ebx,sttwice-stseen
aa@bucket:
  inc	[ebx+4*edx].dword0
  pop	ebx ;Task
  pop	eax ;TT bits
  pop	edx ;Count
  shr	eax,tt_BITSperFlags
  inc	esi
  dec	edx
  jnz	aa@ttloop
aa@next:  
  popm	edi,edx,ebx ;TT.index,TT.endIndex, Truthtables
  add	ebx,4
  cmp	ebx,edx
  jb	aa@loop
  popm	edi,esi,ebx ;preserved
  ret	;ret OK -- end of tt_statisticsTT_c

;  procret <norm>,<noresult>,'ztt8cnt' 
tt_statisticsTT_c ENDP

;;get Bucket for Truthtable and Task
;
;	EBX= Task
;	ESI= Truthtable
;returns:
;	EDX= Bucket
;	EBX,ESI,EDI preserved

aa@getbucket:
  mov	edx,esi					;;Bucket <- TruthTable
  mov	ecx,[ebx].bucketType  ;;case of Task->bucketType
  cmp	cx,tt_MAXnibble
  jbe	aa@nibbleBucket
  cmp	cx,tt_IShighLow
  je	aa@highlow
  cmp	cx,tt_IShighLowBit
  je	aa@highlowbit
  cmp	cx,tt_ISnumBit
  je	aa@numbit
  cmp	cx,tt_ISlowNibble
  je	aa@lownibble	
  cmp	cx,tt_ISlowNibble2
  je	aa@lownibble2		;;.otherwise
  clear	edx					;;..clear Bucket
  ret	;ret ok -- end of aa@getbucket

aa@nibbleBucket:			;;.nibbleN
  shr	edx,cl				;;..Bucket <- (Bucket >> .bucketType) & .nibbleMask			
  and	edx,0Fh	
  ret	;ret ok -- end of aa@getbucket
  
aa@highlow:
  push	ebx ;preserved along with esi and edi
  mov	eax,esi
  clear	edx
  mov	ebx,1 
  mov	ecx,8 ;nibbles per int
aa@nibloop:				;;for each Nibble
  push	eax
  and	eax,0Fh		;;low if 0, 1, 2, or 4 bits w/o 09h or 06h 
  cmp	al,05		;;  these are the nibbles from one 3-SAT
  jbe	aa@nibnext
  cmp	al,08h
  je	aa@nibnext
  cmp	al,0ah
  je	aa@nibnext
  cmp	al,0ch
  je	aa@nibnext
  cmp	al,0fh
  je	aa@nibnext
  or	edx,ebx
aa@nibnext:
  pop	eax
  shr	eax,4
  shl	ebx,1
  loop	aa@nibloop
  ;EDX= bucket
  pop	ebx ;preserved along with esi and edi
  ret	;ret ok -- end of aa@getbucket

aa@highlowbit:
  call	aa@ishigh ;ebx,esi,edi
  jc	aa@rethigh
  clear	edx
  bsr	edx,esi
  ret	;ret ok -- end of aa@getbucket
  
aa@lownibble:
  call	aa@ishigh ;ebx,esi,edi,>edx
  jc	aa@rethigh
  ret	;ret ok -- end of aa@getbucket

aa@lownibble2:
  call	aa@ishigh ;ebx,esi,edi,>edx
  jc	aa@testB
  pushm	edx,esi  ;go with the smaller
  ror	esi,1
  call	aa@ishigh ;ebx,esi,edi,>edx
  mov	eax,edx
  popm	esi,edx ;go with...
  jc	aa@retA
  cmp	eax,edx
  ja	aa@retA
  mov	edx,eax  
aa@retA:
  ret	;ret ok -- end of aa@getbucket

aa@testB:
  push	esi
  ror	esi,1
  call	aa@ishigh ;ebx,esi,edi,>edx
  pop	esi
  jc	aa@rethigh
  ret	;ret ok -- end of aa@getbucket

aa@rethigh:
  mov	edx,tt_NUMbuckets-1
  ret	;ret ok -- end of aa@getbucket
  
aa@numbit:					;;.numBit
  callz	zbitcnt ;ecx,esi,edi,>eax ;;..get bit Count for Truthtable
  mov	edx,eax				;;..Bucket <- Count
  ret	;ret ok -- end of aa@getbucket
  
;;if high Nibble in Truthtable
;	ESI= Truthtable
;returns:
;	C set if true
;	if false
;		EDX= number of non-zero nibbles
;	EBX,ESI,EDI preserved
aa@ishigh:
  mov	eax,esi
  mov	ecx,8 ;nibbles per int
  clear	edx
aa@nibloop2:			;;for each Nibble in Truthtable
				;ECX= Count, EAX=tt32, EDX=CountNonZero, ESI preserved
  push	eax ;tt32
  and	eax,0Fh		;;low if 0, 1, 2, or 4 bits w/o 09h or 06h 
  jz	aa@nibnext2
  inc	edx
  cmp	al,05		;;  these are the nibbles from one 3-SAT
  jbe	aa@nibnext2
  cmp	al,08h
  je	aa@nibnext2
  cmp	al,0ah
  je	aa@nibnext2
  cmp	al,0ch
  je	aa@nibnext2
  cmp	al,0fh
  je	aa@nibnext2
  pop	eax
  stc
  ret	;ret ok -- end of aa@ishigh
aa@nibnext2:
  pop	eax ;tt32
  shr	eax,4
  loop	aa@nibloop2
  clc
  ret	;ret ok -- end of aa@ishigh


	END
